/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.clusterjpa.jsf;

import es.rickyepoderi.clusterjpa.persintence.JdbcSession;
import es.rickyepoderi.clusterjps.ejb.SessionManager;
import java.io.Serializable;
import java.util.List;
import javax.enterprise.context.SessionScoped;
import javax.inject.Inject;
import javax.inject.Named;

/**
 *
 * @author ricky
 */
@Named(value = "sessionBean")
@SessionScoped
public class SessionBean implements Serializable {
    
    @Inject
    SessionManager manager;
    
    private String newValue = null;
    
    private String newKey = null;
    
    private JdbcSession selectedSession = null;
    
    private List<JdbcSession> allSessions = null;
    
    public SessionBean() {
        this.allSessions = null;
        this.selectedSession = null;
    }
    
    public List<JdbcSession> getAllSessions() {
        if (this.allSessions == null) {
            refresh();
        }
        return allSessions;
    }
    
    public JdbcSession getSelectedSession() {
        return selectedSession;
    }

    public String getNewValue() {
        return newValue;
    }

    public void setNewValue(String newValue) {
        this.newValue = newValue;
    }

    public String getNewKey() {
        return newKey;
    }

    public void setNewKey(String newKey) {
        this.newKey = newKey;
    }
    
    public String refresh() {
        this.allSessions = manager.getAllSessions();
        if (selectedSession != null) {
            selectSession(selectedSession.getId());
        }
        return "";
    }
    
    public String evict() {
        // clear cache and refresh data
        manager.evict();
        return refresh();
    }
    
    public String addSession() {
        selectedSession = manager.addSession();
        refresh();
        return "";
    }
    
    public String deleteSession(long id) {
        manager.deleteSession(id);
        if (selectedSession != null && selectedSession.getId() == id) {
            selectedSession = null;
        }
        refresh();
        return "";
    }
    
    public String selectSession(long id) {
        selectedSession = manager.getSession(id);
        return "";
    }
    
    public String addAttribute() {
        if (selectedSession != null && 
                newKey != null && !newKey.isEmpty() &&
                newValue != null && !newValue.isEmpty()) {
            selectedSession = manager.addAttribute(selectedSession.getId(),
                    newKey, newValue);
            newKey = null;
            newValue = null;
            refresh();
        }
        return "";
    }
    
    public String removeAttribute(String key) {
        if (selectedSession != null) {
            refresh();
            selectedSession = manager.removeAttribute(selectedSession.getId(), key);
        }
        return "";
    }
}
