/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.clusterjpa.persintence;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.persistence.CollectionTable;
import javax.persistence.Column;
import javax.persistence.ElementCollection;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.GenerationType;
import javax.persistence.JoinColumn;
import javax.persistence.MapKeyColumn;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;

/**
 *
 * @author ricky
 */
@Entity
@Table(name="JDBCSESSION")
@NamedQueries({
  @NamedQuery(name = JdbcSession.ALL_SESSIONS, 
        query = "SELECT s FROM JdbcSession AS s")
})
public class JdbcSession implements Serializable {

    final static public String ALL_SESSIONS = "ALL_SESSIONS";
    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="ID")
    private Long id;
    
    @Column(name = "CREATION_DATE")
    @Temporal(javax.persistence.TemporalType.TIMESTAMP)
    private Date creationDate = null;

    @Column(name = "MODIFICATION_DATE")
    @Temporal(javax.persistence.TemporalType.TIMESTAMP)
    private Date modificationDate = null;
    
    @ElementCollection(fetch = FetchType.LAZY)
    @CollectionTable(name="ATTRIBUTE", joinColumns=@JoinColumn(name="ID"))
    @MapKeyColumn(name="ATTR_NAME")
    @Column(name="ATTR_VALUE")
    private Map<String, String> attributes = new HashMap<>();
    
    public JdbcSession() {
        creationDate = new Date();
    }
    
    public JdbcSession(long id) {
        this.id = id;
        creationDate = new Date();
    }
    
    public Long getId() {
        return id;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public Date getModificationDate() {
        return modificationDate;
    }
    
    public void updateDate() {
        this.modificationDate = new Date();
    }
    
    public List<Map.Entry<String,String>> getAttributes() {
        return new ArrayList(attributes.entrySet());
    }
    
    public void add(String key, String value) {
        attributes.put(key, value);
    }
    
    public void remove(String key) {
        attributes.remove(key);
    }
    
}
