/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.clusterjps.ejb;

import es.rickyepoderi.clusterjpa.persintence.JdbcSession;
import java.util.List;
import javax.ejb.Stateless;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author ricky
 */
@Named
@Stateless
public class SessionManager {
    
    @PersistenceContext
    EntityManager em;
    
    public SessionManager() {
        // nothing
    }
    
    public JdbcSession addSession() {
        JdbcSession session = new JdbcSession(); 
        em.persist(session);
        return session;
    }
    
    public List<JdbcSession> getAllSessions() {
        return em.createNamedQuery(JdbcSession.ALL_SESSIONS).getResultList();
    }
    
    public JdbcSession getSession(long id) {
        return em.find(JdbcSession.class, id);
    }
    
    public void deleteSession(long id) {
        JdbcSession sess = getSession(id);
        em.remove(sess);
    }
    
    public JdbcSession addAttribute(long id, String name, String value) {
        JdbcSession sess = getSession(id);
        sess.add(name, value);
        sess.updateDate();
        em.persist(sess);
        return sess;
    }
    
    public JdbcSession removeAttribute(long id, String name) {
        JdbcSession sess = getSession(id);
        sess.remove(name);
        sess.updateDate();
        em.persist(sess);
        return sess;
    }
    
    public void evict() {
        em.getEntityManagerFactory().getCache().evictAll();
    }
}
